<?php

class user_model extends CI_Model {

    public function __construct() {
        parent::__construct();
        $this->checkAllHashedUser();
    }

    function checkUser($user_name, $password) {
	$this->checkAllHashedUser();
        $user_name = base64_url_encode($user_name);
        $password = base64_url_encode($password);
        $this->db->where('user_name', $user_name);
        $this->db->where('password', $password);
        $this->db->where('is_active', true);
        $query = $this->db->get('admin_user')->result();
        if (count($query) > 0) {
            $lastLoginTryTime = $query[0]->lastLoginTryTime;
            $lastLoginTryTime = new DateTime($lastLoginTryTime);
            $retryCount = $query[0]->retryCount;
            $lastLoginTryTime->modify("+ 2 minutes");
            if ($retryCount < 3 || $lastLoginTryTime < new DateTime()) {
                $retryCount = 0;
                $this->db->where('user_name', $user_name);
                $this->db->update('admin_user', $data = array(
                    'retryCount' => $retryCount
                ));
                return true;
            } else {
                return false;
            }
        } else {
            $this->db->where('user_name', $user_name);
            $this->db->where('is_active', true);
            $query = $this->db->get('admin_user')->result();
            if (count($query) > 0) {
                $retryCount = $query[0]->retryCount;
                $retryCount++;
                if ($retryCount >= 3) {
                    $retryCount = 3;
                    $data = array(
                        'retryCount' => $retryCount,
                    );
                } else {
                    $data = array(
                        'retryCount' => $retryCount,
                        'lastLoginTryTime' => date('Y-m-d H:i:s')
                    );
                }
                $this->db->where('user_name', $user_name);
                $this->db->update('admin_user', $data);
                return false;
            }
        }
    }

    function checkRetry($user_name) {
        $user_name = base64_url_encode($user_name);
        $string = "User couldn't be verified.";
        $this->db->where('user_name', $user_name);
        $this->db->where('is_active', true);
        $query = $this->db->get('admin_user')->result();

        if (count($query) > 0) {
            $retryCount = $query[0]->retryCount;
            $lastLoginTryTime = $query[0]->lastLoginTryTime;
            $lastLoginTryTime = new DateTime($lastLoginTryTime);
            $lastLoginTryTime->modify("+ 2 minutes");
            if (!($retryCount < 3 || $lastLoginTryTime < new DateTime())) {
                $string = "Maximum limit of retry has been reached please try again after 30 minutes.";
            }
        }
        return $string;
    }

    function checkAllHashedUser() {
        $this->db->select('id,user_name,first_name,last_name,password,contact_email,isHashed');
        $this->db->where('isHashed', false);
        $query = $this->db->get('admin_user')->result();
        if(isset($query) && count($query) > 0){
            foreach ($query as $row) {
                $this->db->where('id', $row->id);
                $this->db->update('admin_user', array(
                    'user_name' => base64_url_encode($row->user_name),
                    'first_name' => base64_url_encode($row->first_name),
                    'password' => base64_url_encode($row->password),
                    'last_name' => base64_url_encode($row->last_name),
                    'contact_email' => base64_url_encode($row->contact_email),
                    'isHashed' => true
                ));
            }
        }
    }

}

?>